// Caricamento delle librerie e inizializzazione delle variabili
import processing.serial.*;
import cc.arduino.*;
Arduino arduino;
color off = color(4, 79, 111);
color on = color(84, 145, 158);

int[] values = { Arduino.LOW, Arduino.LOW, Arduino.LOW, Arduino.LOW,
 Arduino.LOW, Arduino.LOW, Arduino.LOW, Arduino.LOW, Arduino.LOW,
 Arduino.LOW, Arduino.LOW, Arduino.LOW, Arduino.LOW, Arduino.LOW };

// Impostazione della dimensione della finestra, della porta seriale a 57600 Baud
// e inizializzazione dei 14 pin digitali di Arduino
void setup() {
  size(470, 200);
  
  println(Arduino.list());
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  
  for (int i = 0; i <= 13; i++)
    arduino.pinMode(i, Arduino.OUTPUT);
}

// Quella che segue è la funzione di disegno di Processing.
// Il risultato è un rettangolo di 470x200 pixel con 14 quadrati allineati all'interno.
void draw() {
  background(off);
  stroke(on);
  
  for (int i = 0; i <= 13; i++) {
    if (values[i] == Arduino.HIGH)
      fill(on);
    else
      fill(off);
      
    rect(420 - i * 30, 30, 20, 20);
  }
}

// Quella che segue è la funzione di input del mouse.
// Quando un quadrato viene cliccato, si attiva la porta di Arduino corrispondente.
void keyPressed() {
  int pin;
  if (key == 'A') {
    pin = 13;
values[pin] = Arduino.HIGH;
arduino.digitalWrite(pin, Arduino.HIGH);
  }
  if (key == 'a') {
    pin = 13;
values[pin] = Arduino.LOW;
arduino.digitalWrite(pin, Arduino.LOW);
  }
}

